class BaseHeightCache {
  heights: Record<string, number>;
  DEFAULT_HEIGHT: number;
  constructor(props?: any) {
    const r = arguments.length > 0 && void 0 !== arguments[ 0 ] ? arguments[ 0 ] : {},
      t = r.DEFAULT_HEIGHT,
      n = void 0 === t ? 50 : t;
    this.heights = {};
    this.DEFAULT_HEIGHT = n;
  }

  get( r: string ) {
    if ( r in this.heights ) return this.heights[ r ];
    return this.DEFAULT_HEIGHT;
  }

  set( r: string, t: number ) {
    this.heights[ r ] = t;
  }

  getValidity( r: string ) {
    return r in this.heights;
  }
}

export class HeightCache extends BaseHeightCache {
  validity: Record<string, boolean>;
  constructor( props?: any ) {
    super( props );
    this.validity = {};
  }

  getValidity( r: string ) {
    return !! this.validity[ r ];
  }

  hasAllValidity() {
    const v = Object.values(this.validity);
    console.log('v: ', v);
    return v.every(e => e) && v.length === Object.values(this.heights).length;
  }

  set( t: string, n: number ) {
    super.set( t, n );
    this.validity[ t ] = true;
  }

  invalidate( r?: string ) {
    if ( ! r ) {
      this.validity = {};
      return;
    }
    delete this.validity[ r ];
  }
}
